Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 15032)
@@ -11,8 +11,7 @@
 
   /// <summary>
-  ///     Defines the name on top of the NAME stack as an instruction that will push the top item of the T stack onto the
-  ///     EXEC stack.
+  /// Defines the name on top of the NAME stack as an instruction that will push the top item of the T stack onto the EXEC stack.
   /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
+  /// <typeparam name="T">Stack item type</typeparam>
   [StorableClass]
   public abstract class DefineExpression<T> : StatelessExpression {
@@ -34,5 +33,9 @@
   }
 
-  [PushExpression(StackTypes.Code, "CODE.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the CODE stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class CodeDefineExpression : DefineExpression<Expression> {
@@ -60,5 +63,10 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.DEFINE", StackTypes.Name, execIn: 1)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the EXEC stack onto the EXEC stack.",
+    StackTypes.Name,
+    execIn: 1)]
   [StorableClass]
   public class ExecDefineExpression : DefineExpression<Expression> {
@@ -85,5 +93,9 @@
   }
 
-  [PushExpression(StackTypes.Float, "FLOAT.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the FLOAT stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class FloatDefineExpression : DefineExpression<double> {
@@ -108,5 +120,9 @@
   }
 
-  [PushExpression(StackTypes.Integer, "INTEGER.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the INTEGER stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class IntegerDefineExpression : DefineExpression<long> {
@@ -131,5 +147,9 @@
   }
 
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the BOOLEAN stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class BooleanDefineExpression : DefineExpression<bool> {
@@ -154,5 +174,9 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the CHAR stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class CharDefineExpression : DefineExpression<char> {
@@ -177,5 +201,9 @@
   }
 
-  [PushExpression(StackTypes.String, "STRING.DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the STRING stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class StringDefineExpression : DefineExpression<string> {
@@ -200,5 +228,9 @@
   }
 
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the INTEGER[] stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class IntegerVectorDefineExpression : DefineExpression<IReadOnlyList<long>> {
@@ -223,5 +255,9 @@
   }
 
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the FLOAT[] stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class FloatVectorDefineExpression : DefineExpression<IReadOnlyList<double>> {
@@ -246,5 +282,9 @@
   }
 
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the BOOLEAN[] stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class BooleanVectorDefineExpression : DefineExpression<IReadOnlyList<bool>> {
@@ -269,5 +309,9 @@
   }
 
-  [PushExpression(StackTypes.StringVector, "STRING[].DEFINE", StackTypes.Name)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].DEFINE",
+    "Defines the name on top of the NAME stack as an instruction that will push the top item of the STRING[] stack onto the EXEC stack.",
+    StackTypes.Name)]
   [StorableClass]
   public class StringVectorDefineExpression : DefineExpression<IReadOnlyList<string>> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 15032)
@@ -16,5 +16,9 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.DO*COUNT", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DO*COUNT",
+    "An iteration instruction that performs a loop (the body of which is taken from the CODE stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body.",
+    StackTypes.Integer)]
   public class CodeDoCountExpression : StatelessExpression {
 
@@ -48,5 +52,10 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*COUNT", StackTypes.Integer, execIn: 1)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.DO*COUNT",
+    "An iteration instruction that performs a loop (the body of which is taken from the EXEC stack) the number of times indicated by the INTEGER argument, pushing an index (which runs from zero to one less than the number of iterations) onto the INTEGER stack prior to each execution of the loop body.",
+    StackTypes.Integer,
+    execIn: 1)]
   public class ExecDoCountExpression : StatelessExpression {
     public ExecDoCountExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 15032)
@@ -21,5 +21,9 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.DO*RANGE", StackTypes.Integer)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.DO*RANGE",
+    "An iteration instruction that executes the top item on the CODE stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop.",
+    StackTypes.Integer)]
   public class CodeDoRangeExpression : StatelessExpression {
     public CodeDoRangeExpression() { }
@@ -74,5 +78,10 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*RANGE", StackTypes.Integer, execIn: 1)]
+  [PushExpression(
+    stackType: StackTypes.Exec,
+    name: "EXEC.DO*RANGE",
+    description: "An iteration instruction that executes the top item on the EXEC stack a number of times that depends on the top two integers, while also pushing the loop counter onto the INTEGER stack for possible access during the execution of the body of the loop.",
+    additionalStackDependencies: StackTypes.Integer,
+    execIn: 1)]
   public class ExecDoRangeExpression : StatelessExpression {
     public ExecDoRangeExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15032)
@@ -14,5 +14,5 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.DO*TIMES", StackTypes.Integer)]
+  [PushExpression(StackTypes.Code, "CODE.DO*TIMES", "Like CODE.DO*COUNT but does not push the loop counter", StackTypes.Integer)]
   public class CodeDoTimesExpression : StatelessExpression {
     public CodeDoTimesExpression() { }
@@ -61,15 +61,12 @@
 
   /// <summary>
-  ///     Like EXEC.DO*COUNT but does not push the loop counter. This should be implemented as a macro that expands into
-  ///     EXEC.DO*RANGE,
-  ///     similarly to the implementation of EXEC.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the
-  ///     front of the
-  ///     loop body code in the call to EXEC.DO*RANGE. This call to INTEGER.POP will remove the loop counter, which will have
-  ///     been
-  ///     pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
+  /// Like EXEC.DO*COUNT but does not push the loop counter. This should be implemented as a macro that expands into
+  /// EXEC.DO*RANGE, similarly to the implementation of EXEC.DO*COUNT, except that a call to INTEGER.POP should be tacked on to the
+  /// front of the loop body code in the call to EXEC.DO*RANGE. This call to INTEGER.POP will remove the loop counter, which will have
+  /// been pushed by EXEC.DO*RANGE, prior to the execution of the loop body.
   /// </summary>
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", StackTypes.Integer, execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", "Like EXEC.DO*COUNT but does not push the loop counter", StackTypes.Integer, execIn: 1)]
   public class ExecDoTimesExpression : StatelessExpression {
     public ExecDoTimesExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15032)
@@ -8,6 +8,6 @@
 
   /// <summary>
-  ///     Duplicates the top item on the INTEGER stack. Does not pop its argument
-  ///     (which, if it did, would negate the effect of the duplication!).
+  /// Duplicates the top item on the T stack. Does not pop its argument
+  /// (which, if it did, would negate the effect of the duplication!).
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
@@ -24,5 +24,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.DUP")]
+  [PushExpression(StackTypes.Integer, "INTEGER.DUP", "Duplicates the top item on the INTEGER stack.")]
   public class IntegerDuplicateExpression : DuplicateExpression<long> {
     public IntegerDuplicateExpression() { }
@@ -40,5 +40,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.DUP")]
+  [PushExpression(StackTypes.Float, "FLOAT.DUP", "Duplicates the top item on the FLOAT stack.")]
   public class FloatDuplicateExpression : DuplicateExpression<double> {
     public FloatDuplicateExpression() { }
@@ -56,5 +56,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.DUP")]
+  [PushExpression(StackTypes.Boolean, "BOOLEAN.DUP", "Duplicates the top item on the BOOLEAN stack.")]
   public class BooleanDuplicateExpression : DuplicateExpression<bool> {
     public BooleanDuplicateExpression() { }
@@ -72,5 +72,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.DUP")]
+  [PushExpression(StackTypes.Name, "NAME.DUP", "Duplicates the top item on the NAME stack.")]
   public class NameDuplicateExpression : DuplicateExpression<string> {
     public NameDuplicateExpression() { }
@@ -88,5 +88,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DUP", execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.DUP", "Duplicates the top item on the EXEC stack." , execIn: 1)]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
     public ExecDuplicateExpression() { }
@@ -104,5 +104,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.DUP")]
+  [PushExpression(StackTypes.Code, "CODE.DUP", "Duplicates the top item on the CODE stack.")]
   public class CodeDuplicateExpression : DuplicateExpression<Expression> {
     public CodeDuplicateExpression() { }
@@ -120,5 +120,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.DUP")]
+  [PushExpression(StackTypes.Char, "CHAR.DUP", "Duplicates the top item on the CHAR stack.")]
   public class CharDuplicateExpression : DuplicateExpression<char> {
     public CharDuplicateExpression() { }
@@ -136,5 +136,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.DUP")]
+  [PushExpression(StackTypes.String, "STRING.DUP", "Duplicates the top item on the STRING stack.")]
   public class StringDuplicateExpression : DuplicateExpression<string> {
     public StringDuplicateExpression() { }
@@ -152,5 +152,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].DUP")]
+  [PushExpression(StackTypes.IntegerVector, "INTEGER[].DUP", "Duplicates the top item on the INTEGER[] stack.")]
   public class IntegerVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<long>> {
     public IntegerVectorDuplicateExpression() { }
@@ -168,5 +168,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].DUP")]
+  [PushExpression(StackTypes.FloatVector, "FLOAT[].DUP", "Duplicates the top item on the FLOAT[] stack.")]
   public class FloatVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<double>> {
     public FloatVectorDuplicateExpression() { }
@@ -184,5 +184,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].DUP")]
+  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].DUP", "Duplicates the top item on the BOOLEAN[] stack.")]
   public class BooleanVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<bool>> {
     public BooleanVectorDuplicateExpression() { }
@@ -200,5 +200,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].DUP")]
+  [PushExpression(StackTypes.StringVector, "STRING[].DUP", "Duplicates the top item on the STRING[] stack.")]
   public class StringVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<string>> {
     public StringVectorDuplicateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15032)
@@ -27,5 +27,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the EXEC stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class ExecEmptyExpression : EmptyExpression<Expression> {
     public ExecEmptyExpression() { }
@@ -39,5 +43,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the CODE stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class CodeEmptyExpression : EmptyExpression<Expression> {
     public CodeEmptyExpression() { }
@@ -50,5 +58,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the INTEGER stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class IntegerEmptyExpression : EmptyExpression<long> {
     public IntegerEmptyExpression() { }
@@ -60,5 +72,8 @@
   }
 
-  [PushExpression(StackTypes.Float, "FLOAT.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.EMPTY", "Pushes TRUE onto the BOOLEAN stack if the FLOAT stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class FloatEmptyExpression : EmptyExpression<double> {
     public FloatEmptyExpression() { }
@@ -70,5 +85,9 @@
   }
 
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the BOOLEAN stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class BooleanEmptyExpression : EmptyExpression<bool> {
     public BooleanEmptyExpression() { }
@@ -80,5 +99,9 @@
   }
 
-  [PushExpression(StackTypes.Char, "CHAR.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the CHAR stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class CharEmptyExpression : EmptyExpression<char> {
     public CharEmptyExpression() { }
@@ -90,5 +113,9 @@
   }
 
-  [PushExpression(StackTypes.String, "STRING.EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the STRING stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class StringEmptyExpression : EmptyExpression<string> {
     public StringEmptyExpression() { }
@@ -100,5 +127,9 @@
   }
 
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the INTEGER[] stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class IntegerVectorEmptyExpression : EmptyExpression<IReadOnlyList<long>> {
     public IntegerVectorEmptyExpression() { }
@@ -110,5 +141,9 @@
   }
 
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the FLOAT[] stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class FloatVectorEmptyExpression : EmptyExpression<IReadOnlyList<double>> {
     public FloatVectorEmptyExpression() { }
@@ -120,5 +155,9 @@
   }
 
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the BOOLEAN[] stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class BooleanVectorEmptyExpression : EmptyExpression<IReadOnlyList<bool>> {
     public BooleanVectorEmptyExpression() { }
@@ -130,5 +169,9 @@
   }
 
-  [PushExpression(StackTypes.StringVector, "STRING[].EMPTY", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].EMPTY",
+    "Pushes TRUE onto the BOOLEAN stack if the STRING[] stack is empty, otherwise FALSE.",
+    StackTypes.Boolean)]
   public class StringVectorEmptyExpression : EmptyExpression<IReadOnlyList<string>> {
     public StringVectorEmptyExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15031)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15032)
@@ -11,5 +11,5 @@
 
   /// <summary>
-  ///     Pushes TRUE onto the BOOLEAN stack if the top two items are equal, or FALSE otherwise
+  /// Pushes TRUE onto the T stack if the top two items are equal, or FALSE otherwise
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
@@ -40,5 +40,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Integer, "INTEGER.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Integer,
+    "INTEGER.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two INTEGER items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class IntegerEqualsExpression : EqualsExpression<long> {
     public IntegerEqualsExpression() { }
@@ -56,5 +60,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Float, "FLOAT.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Float,
+    "FLOAT.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two FLOAT items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class FloatEqualsExpression : EqualsExpression<double> {
     public FloatEqualsExpression() { }
@@ -72,5 +80,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Boolean, "BOOLEAN.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Boolean,
+    "BOOLEAN.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two BOOLEAN items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class BooleanEqualsExpression : EqualsExpression<bool> {
     public BooleanEqualsExpression() { }
@@ -88,5 +100,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Name, "NAME.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Name,
+    "NAME.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two NAME items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class NameEqualsExpression : EqualsExpression<string> {
     public NameEqualsExpression() { }
@@ -104,5 +120,10 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.=", StackTypes.Boolean, execIn: 0)]
+  [PushExpression(
+    StackTypes.Exec,
+    "EXEC.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two EXEC items are equal, or FALSE otherwise.",
+    StackTypes.Boolean,
+    execIn: 0)]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
     public ExecEqualsExpression() { }
@@ -120,5 +141,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Code, "CODE.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Code,
+    "CODE.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two CODE items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class CodeEqualsExpression : EqualsExpression<Expression> {
     public CodeEqualsExpression() { }
@@ -136,5 +161,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Char, "CHAR.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.Char,
+    "CHAR.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two CHAR items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class CharEqualsExpression : EqualsExpression<char> {
     public CharEqualsExpression() { }
@@ -152,5 +181,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.String, "STRING.=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.String,
+    "STRING.=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two STRING items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class StringEqualsExpression : EqualsExpression<string> {
     public StringEqualsExpression() { }
@@ -168,5 +201,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.IntegerVector, "INTEGER[].=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.IntegerVector,
+    "INTEGER[].=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two INTEGER[] items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class IntegerVectorEqualsExpression : EqualsExpression<long> {
     public IntegerVectorEqualsExpression() { }
@@ -184,5 +221,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.FloatVector, "FLOAT[].=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.FloatVector,
+    "FLOAT[].=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two FLOAT[] items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class FloatVectorEqualsExpression : EqualsExpression<double> {
     public FloatVectorEqualsExpression() { }
@@ -200,5 +241,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.BooleanVector,
+    "BOOLEAN[].=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two BOOLEAN[] items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class BooleanVectorEqualsExpression : EqualsExpression<bool> {
     public BooleanVectorEqualsExpression() { }
@@ -216,5 +261,9 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.StringVector, "STRING[].=", StackTypes.Boolean)]
+  [PushExpression(
+    StackTypes.StringVector,
+    "STRING[].=",
+    "Pushes TRUE onto the BOOLEAN stack if the top two STRING[] items are equal, or FALSE otherwise.",
+    StackTypes.Boolean)]
   public class StringVectorEqualsExpression : EqualsExpression<string> {
     public StringVectorEqualsExpression() { }
